<h1><center>Ansible自动化运维基础</center></h1>

------

**作者：行癫（盗版必究）**

## 一：简介

#### 1.自动化运维工具对比

​		Puppet:基于 Ruby 开发,采用 C/S 架构,扩展性强,基于 SSL,远程命令执行相对较弱

​		SaltStack:基于 Python 开发,采用 C/S 架构,YAML使得配置脚本更简单.需要配置客户端及服务器端；每台被控制节点需要安装agent

​		Ansible:基于 Python开发,分布式,无需客户端,轻量级,配置语法使用YAML语言,更强的远程命令执行操作

#### 2.Ansible简介

​		ansible是新出现的自动化运维工具，基于Python开发，分布式,无需客户端,轻量级，实现了批量系统配置、批量程序部署、批量运行命令等功能，ansible是基于模块工作的,本身没有批量部署的能力。真正具有批量部署的是ansible所运行的模块,ansible只是提供一种框架

特性：

​		no agents：不需要在被管控主机上安装任何客户端,更新时,只需在操作机上进行一次更新即可（不用安装客户端。分布式的）

​		no server：无服务器端,使用时直接运行命令即可

​		modules in any languages：基于模块工作,可使用任意语言开发模块

​		yaml,not code：使用yaml语言定制剧本playbook

​		ssh by default：基于SSH工作

​		strong multi-tier solution：可实现多级指挥

特点：

<img src="https://xingdian-image.oss-cn-beijing.aliyuncs.com/xingdian-image/image-20230228225234537.png" alt="image-20230228225234537" style="zoom:50%;" />

​		connection plugins：连接插件,负责和被监控端实现通信,默认使用SSH连接

​		host inventory：主机清单,是一个配置文件里面定义监控的主机

​		modules : 模块,核心模块、command模块、自定义模块等

​		plugins : modules功能的补充,包括连接插件,邮件插件等

​		playbook：编排,定义 Ansible 多任务配置文件,非必需

#### 3.部署Ansible

环境准备：

```shell
环境:
主机：4台  一个控制节点 3个被控制节点
解析：本地互相解析(所有机器)
# vim /etc/hosts
192.168.1.10 ansible-web1
192.168.1.11 ansible-web2
192.168.1.12 ansible-web3
192.168.1.9  ansible-server  (控制节点服务器端)
配置ssh公钥认证：控制节点需要发送ssh公钥给所有非被控制节点
[root@ansible-server ~]# ssh-keygen
[root@ansible-server ~]# ssh-copy-id -i 192.168.1.10  #所有机器

所有机器：
systemctl stop firewalld && setenforce 0
```

安装ansible：

```shell
安装：控制节点
 1. 配置EPEL网络yum源
 [root@ansible-server ~]# yum install -y epel-release
 2. 安装ansible
 [root@ansible-server ~]# yum install -y ansible
 3.查看版本
 [root@ansiable-server ~]# ansible --version
ansible 2.9.2
  config file = /etc/ansible/ansible.cfg
  configured module search path = [u'/root/.ansible/plugins/modules', u'/usr/share/ansible/plugins/modules']
  ansible python module location = /usr/lib/python2.7/site-packages/ansible
  executable location = /usr/bin/ansible
  python version = 2.7.5 (default, Oct 30 2018, 23:45:53) [GCC 4.8.5 20150623 (Red Hat 4.8.5-36)]

 4.看帮助
 [root@ansible-server ~]# ansible --help
```

## 二：主机清单inventory

​		inventory文件通常用于定义要管理主机及其认证信息，例如ssh登录用户名、密码以及key相关信息

#### 1.配置文件

```shell
vim /etc/ansible/hosts
    web1                  //单独指定主机，可以使用主机名称或IP地址
    web2
    web3
    #-----------------------------------------------------------------
    [webservers]        //使用[]标签指定主机组
        192.168.10.128
        bar.example.com
        up.example.com:5309              //指定 SSH 端口 5309
        web5  ansible_ssh_host=web2  //设置主机web2的别名为 web5
        web1 ansible_ssh_pass='123'  //设置ssh密码，使用-k参数之后提示的密码可以不写，直接回车
        www[01:50].example.com         //支持通配符匹配www01,www02,...,www50
        db-[a:f].example.com                //通配符匹配db-a,db-b,...,db-f    
    #-----------------------------------------------------------------
    为每个主机单独指定变量，这些变量随后可以在 playbooks 中使用：内置变量
    [atlanta]
    host1 http_port=80 maxRequestsPerChild=808
    host2 http_port=303 maxRequestsPerChild=909
    #------------------------------------------------------------------
    为一个组指定变量，组内每个主机都可以使用该变量：
    [atlanta]
    host1
    host2
    [atlanta:vars]
    ansible_ssh_pass='123'
    ntp_server=ntp.atlanta.example.com
    proxy=proxy.atlanta.example.com
    #-----------------------------------------------------------------
    组可以包含其他组：
    [atlanta]
    host1
    host2
    [raleigh]
    host3
    host4
    [southeast:children]   //southeast包括两个子组
    atlanta
    raleigh
    [southeast:vars]
    some_server=foo.southeast.example.com
    halon_system_timeout=30
```

​		ansible基于ssh连接inventory中指定的远程主机时，还可以通过参数指定其交互方式

```shell
    ansible_ssh_host # 远程主机
    ansible_ssh_port # 指定远程主机ssh端口
    ansible_ssh_user # ssh连接远程主机的用户,默认root
    ansible_ssh_pass # 连接远程主机使用的密码,在文件中明文,建议使用--ask-pass或者使用SSH keys
    ansible_sudo_pass # sudo密码, 建议使用--ask-sudo-pass
    ansible_connection # 指定连接类型: local, ssh, paramiko
    ansible_ssh_private_key_file # ssh 连接使用的私钥
    ansible_shell_type # 指定连接对端的shell类型, 默认sh,支持csh,fish
    ansible_python_interpreter # 指定对端使用的python编译器的路径
```

#### 2.使用

​		查看组内主机列表

```
语法：ansible  组名  --list-hosts
[root@xingdian ~]# ansible web --list-hosts
  hosts (2):
    172.17.0.2
    172.17.0.3
```

​		自定义主机列表

```shell
vim /home/ansible/hostlist
[all:vars]
ansible_ssh_port=22
ansible_ssh_user=root
#ansible_ssh_private_key_file=/root/.ssh/id_rsa
ansible_ssh_pass=1
[all]
ansible-web1
ansible-web2
```

​		案例

```shell
[root@ansible-server ~]# ansible -i /opt/hostlist all -m ping -o
-i:指定清单文件
```

注意：

```shell
一个典型的例子就是 shell 和 command 模块. 这两个模块在很多情况下都能完成同样的工作， 以下是两个模块之前的区别：
command 模块命令将不会使用 shell 执行. 因此, 像 $HOME 这样的变量是不可用的。还有像 |,& 都将不可用
shell 模块通过shell程序执行， 默认是/bin/sh, <, >, |, ;, & 可用
```

## 三：点对点Ad-Hoc

​		ad hoc 临时的，在ansible中是指需要快速执行，并且不需要保存的命令

​		简单的命令——一条命令；对于复杂的命令则为 playbook		

#### 1.ansible模块

​		列出ansible支持的模块：

```shell
-l：获取列表
-s module_name：获取指定模块的使用信息
获取模块列表
[root@ansible-server ~]# ansible-doc -l
模块使用格式:
[root@ansible-server ~]# ansible-doc -s yum
```

​		模块官方文档：https://docs.ansible.com/ansible/2.9/modules/list_of_files_modules.html

常用模块

**用户管理模块：user**

​		添加用户并设置密码：

```shell
[root@ansible-server ~]# ansible webservers1 -m user -a "name=liudehua password=`echo 1234 | openssl passwd -1 -stdin`" -o
"name=   "  #如：指定的用户名，要安装的软件
-1 MD5加密算法
```

​		删除用户：

```shell
[root@ansible-server ~]# ansible webservers1 -m user -a "name=liudehua state=absent" -o
adsent #删除用户，但是不会删除家目录
```

**组管理模块：group**

​		参数：

```shell
gid：为组设置的可选GID
name：要管理的组的名称
state：该组是否应该存在于远程主机上；absent不在/默认是present在
system：如果是，表示创建的组是系统组；默认时no
```

​		案例：

```shell
[root@ansible-server ~]# ansible all -m group -a 'name=somegroup state=present'
```

**软件包管理模块：yum**

​		参数：

```shell
config_file：yum的配置文件 
disable_gpg_check：关闭gpg_check 
disablerepo：不启用某个源 
enablerepo：启用某个源
name：要进行操作的软件包的名字，也可以传递一个url或者一个本地的rpm包的路径 
state：状态（present，absent，latest）
```

​		安装apache：

```shell
[root@ansible-server ~]# ansible webservers1 -m yum -a "name=httpd state=latest" -o
state=     #状态是什么，干什么
state=absent        用于remove安装包
state=latest       表示最新的
state=removed      表示卸载
```

​		卸载软件：

```shell
[root@ansible-server ~]# ansible webservers1 -m yum -a "name=httpd state=removed" -o
```

**服务管理模块：service**

​		参数：

```shell
arguments：给命令行提供一些选项 
enabled：是否开机启动 yes|no
name：必选项，服务名称 
pattern：定义一个模式，如果通过status指令来查看服务的状态时，没有响应，就会通过ps指令在进程中根据该模式进行查找，如果匹配到，则认为该服务依然在运行
runlevel：运行级别
sleep：如果执行了restarted，在则stop和start之间沉睡几秒钟
state：对当前服务执行启动，停止、重启、重新加载等操作（started,stopped,restarted,reloaded）
```

​		案例：

```shell
[root@ansible-server ~]# ansible webservers1 -m service -a "name=httpd state=started" #启动
[root@ansible-server ~]# ansible webservers1 -m service -a "name=httpd state=stopped" #停止
[root@ansible-server ~]# ansible webservers1 -m service -a "name=httpd state=restarted" #重启
[root@ansible-server ~]# ansible webservers1 -m service -a "name=httpd state=started enabled=yes" #开机启动
[root@ansible-server ~]# ansible webservers1 -m service -a "name=httpd state=started enabled=no"  #开机关闭
```

**文件模块：file**

​		参数：

```shell
owner:修改属主
group:修改属组
mode:修改权限
path=:要修改文件的路径
recurse：递归的设置文件的属性，只对目录有效
        yes:表示使用递归设置
state:
touch:创建一个新的空文件
directory:当目录存在时不会进行修改
```

​		案例：

```shell
[root@ansible-server ~]# ansible webservers1 -m file -a 'path=/tmp/88.txt mode=777 state=touch' #创建一个文件
[root@ansible-server ~]# ansible webservers1 -m file -a 'path=/tmp/99 mode=777 state=directory' #创建一个目录
```

**收集信息模块：setup**

```shell
[root@ansible-server ~]# ansible webservers1 -m setup  #收集所有信息
[root@ansible-server ~]# ansible webservers1 -m setup -a 'filter=ansible_all_ipv4_addresses' #只查询ipv4的地址
filter:过滤
[root@ansible-server ~]# ansible webservers1 -m setup -a 'filter=ansible_*_mb'
[root@ansible-server ~]# ansible -i /home/ansible/hostlist web -m setup -a 'filter=ansible_processor_cores'
[root@ansible-server ~]# ansible all -m setup --tree /tmp/facts 
```

**文件复制模块：copy**

​		参数：

```shell
backup：在覆盖之前，将源文件备份，备份文件包含时间信息。有两个选项：yes|no
content：用于替代“src”，可以直接设定指定文件的值
dest：必选项。要将源文件复制到的远程主机的绝对路径，如果源文件是一个目录，那么该路径也必须是个目录
directory_mode：递归设定目录的权限，默认为系统默认权限
force：如果目标主机包含该文件，但内容不同，如果设置为yes，则强制覆盖，如果为no，默认为yes
others：所有的file模块里的选项都可以在这里使用
src：被复制到远程主机的本地文件，可以是绝对路径，也可以是相对路径。如果路径是一个目录，它将递归复制。在这种情况下，如果路径使用“/”来结尾，则只复制目录里的内容，如果没有使用“/”来结尾，则包含目录在内的整个内容全部复制
```

​		案例：

```shell
[root@ansible-server ~]# ansible test -m copy -a "src=/srv/myfiles/foo.conf dest=/etc/foo.conf owner=foo group=foo mode=0644"
[root@ansible-server ~]# ansible test -m copy -a "src=/mine/ntp.conf dest=/etc/ntp.conf owner=root group=root mode=644 backup=yes"
```

**计划任务模块：cron**

​		参数：

```shell
backup：对远程主机上的原任务计划内容修改之前做备份 
cron_file：如果指定该选项，则用该文件替换远程主机上的cron.d目录下的用户的任务计划 
day：日（1-31，*，*/2,……） 
hour：小时（0-23，*，*/2，……）  
minute：分钟（0-59，*，*/2，……） 
month：月（1-12，*，*/2，……） 
weekday：周（0-7，*，……）
job：要执行的任务，依赖于state=present 
name：该任务的描述 
special_time：指定什么时候执行，参数：reboot,yearly,annually,monthly,weekly,daily,hourly 
state：确认该任务计划是创建还是删除 
user：以哪个用户的身份执行
```

​		案例：

```shell
[root@ansible-server ~]# ansible test -m cron -a 'name="a job for reboot" special_time=reboot job="/some/job.sh"'
[root@ansible-server ~]# ansible test -m cron -a 'name="yum autoupdate" weekday="2" minute=0 hour=12 user="root
[root@ansible-server ~]# ansible test -m cron  -a 'backup="True" name="test" minute="0" hour="5,2" job="ls -alh > /dev/null"'
[root@ansible-server ~]# ansilbe test -m cron -a 'cron_file=ansible_yum-autoupdate state=absent'
```

#### 2.实战案例

​		获取每台主机的IP地址

```shell
[root@xingdian ~]# ansible -i /home/ansible/hostlist web -m shell -a "ip a | grep eth0| awk 'NR==2{print $2}'" -o > a.txt && cat a.txt |awk '{print $9,$NF}'
```

​		获取每台主机的内存

```shell
[root@xingdian ~]# ansible -i /home/ansible/hostlist web -m shell -a "free -m | awk 'NR==2'" > b.txt -o && cat b.txt | awk '{print $10}'
```

## 四：剧本Playbook

#### 1.介绍

​		playbook是ansible用于配置，部署，和管理被控节点的剧本。通过playbook的详细描述，执行其中的tasks，可以让远端主机达到预期的状态。playbook是由一个或多个”play”组成的列表。  当对一台机器做环境初始化的时候往往需要不止做一件事情，这时使用playbook会更加适合。通过playbook你可以一次在多台机器执行多个指令。通过这种预先设计的配置保持了机器的配置统一，并很简单的执行日常任务

#### 2.格式

​		playbook由YMAL语言编写。YMAL格式是类似于JSON的文件格式，便于人理解和阅读，同时便于书写

​		yaml介绍见另一章

#### 3.核心元素

​		Variables     #变量元素,可传递给Tasks/Templates使用

​		Tasks           #任务元素,由模块定义的操作的列表，即调用模块完成任务

​		Templates    #模板元素,使用了模板语法的文本文件，可根据变量动态生成配置文件

​		Handlers      #处理器元素,通常指在某事件满足时触发的操作

​		Roles           #角色元素

注意：

​		一个剧本里面可以有多个play，每个play只能有一个tasks，每个tasks可以有多个name

#### 4.基础组件

name：

​		定义playbook或者task的名称(描述信息)，每一个play都可以完成一个任务

hosts：

​		playbook中的每一个paly的目的都是为了让某个或某些以某个指定用户的身份执行任务；与命令模式下的ansible匹配规则一样

user：

​		remote_user则用于指定远程主机上的执行任务的用户，也可以使用user（基本上是root）

tasks：

​		任务列表play的主体部分是task list. task list中的各任务按次序逐个在hosts中指定的所有主机上执行

vars：

​		定义变量（如果不使用内部变量需要提前定义）

vars_files：

​		调用定义变量文件

notify：

​		任务执行结果如果是发生更改了的则触发定义在handler的任务执行

handlers：

​		用于当前关注的资源发生变化时采取一定指定的操作

include：

​		能包含的包括task，handler和playbook；可以在include的时候传递变量

## 五：剧本案例

#### 1.案例一

```
[root@ansible-server ~]# cd /etc/ansible/
[root@ansible-server ansible]# vim test.yml  #创建文件必须以.yml结尾
---
 - hosts: webservers1
   user: root
   tasks:
   - name: playbook_test
     file: state=touch path=/tpm/playbook.txt
```

参数解释

​		hosts：参数指定了对哪些主机进行操作

​		user：参数指定了使用什么用户登录远程主机操作

​		tasks：指定了一个任务

​		name：参数同样是对任务的描述，在执行过程中会打印出

检测语法

```shell
[root@ansible-server ansible]# ansible-playbook --syntax-check test.yml 
playbook: test.yml
```

运行Playbook

```shell
[root@ansible-server ansible]# ansible-playbook test.yml
```

#### 2.案例二

​		handlers：由特定条件触发的Tasks

语法

```yaml
tasks：
- name: TASK_NAME
  module: arguments              #1.上面任务执行成功，然后
  notify: HANDLER_NAME           #2.通知他
handlers:
- name: HANDLER_NAME             #3.一一对应，这里的描述与notify定义的必须一样
  module: arguments              #4.执行这个命令
```

案例

```yaml
[root@ansible-server ansible]# vim handlers.yml
- hosts: webservers1
  user: root
  tasks:
  - name: test copy
    copy: src=/root/a.txt dest=/mnt
    notify: test handlers
  handlers:
  - name: test handlers
    shell: echo "abcd" >> /mnt/a.txt
```

注意：

​		只有 copy 模块真正执行后，才会去调用下面的 handlers 相关的操作，追加内容。所以这种比较适合配置文件发生更改后，需要重启服务的操作

检测语法

```shell
[root@ansible-server ansible]# ansible-playbook --syntax-check handlers.yml
playbook: handlers.yml
```

运行剧本

```shell
[root@ansible-server ansible]# ansible-playbook handlers.yml
```

#### 3.案例三

安装nginx并启动服务

```
[root@ansible-server ansible]# vim /home/ansible/yum.yml
---
 - hosts: web
   user: root
   tasks:
   - name: install nginx
     yum: name=nginx state=latest
     notify: diandian
   handlers:
   - name: diandian
     service: name=nginx state=started
```

检测语法

```shell
[root@ansible-server ansible]# ansible-playbook --syntax-check /home/ansible/yum.yml
playbook: handlers.yml
```

运行剧本

```shell
[root@ansible-server ansible]# ansible-playbook /home/ansible/yum.yml
```

4.案例四

​		循环：迭代，需要重复执行的任务

​		对迭代项的引用，固定变量名为”item”，使用with_items属性给定要迭代的元素

​		元素：1.列表 2.字符串 3.字典

**基于字符串列表元素实战**

```yaml
[root@ansible-server ansible]# vim list.yml
- hosts: websrvs
  remote_user: root
  tasks:
  - name: install packages
    yum: name={{ item }} state=latest         #相当于for循环里面的i 
    with_items:                               #取值 。但是不支持通配符
     - httpd
     - php
     - php-mysql
     - php-mbstring
     - php-gd 
```

语法检测

```shell
[root@ansible-server ansible]# ansible-playbook --syntax-check list.yml 
playbook: list.yml
```

运行剧本

```shell
[root@ansible-server ansible]# ansible-playbook  list.yml
```

**基于字典列表给元素示例**

```
[root@ansible-server ansible]# vim zidian.yml
- hosts: all
  user: root
  tasks:
  - name: create groups
    group: name={{ item }} state=present
    with_items:
    - groupx1
    - groupx2
    - groupx3
   - name: create users
     user: name={{ item.name }} group={{ item.group }} state=present
     with_items:     #这里使用的是字典
     - {name: 'userx1', group: 'groupx1'}
     - {name: 'userx2', group: 'groupx2'}
     - {name: 'userx3', group: 'groupx3'}
```

语法检测

```shell
[root@ansible-server ansible]# ansible-playbook --syntax-check zidian.yml 
playbook: zidian.yml
```

运行剧本

```shell
[root@ansible-server ansible]# ansible-playbook  zidian.yml
```

#### 4.案例四

tags使用

​		给指定的任务定义一个调用标识，形式如下；只运行指定标记的任务：-t tags

```shell
[root@ansible ansible]# ansible-playbook  -t 标记名称 test.yml 
```

​		跳过某一个被标记的任务：--skip-tags=SKIP_TAGS 

```shell
[root@ansible ansible]# ansible-playbook  --skip-tags=标记名称 test.yml
```

​		从某一个任务开始往下运行：--start-at-task 任务名称

```shell
[root@ansible ansible]# ansible-playbook  --start-at-task "start httpd service" test.yml 
```

案例

```yaml
[root@xingdian /]# vim /home/ansible/tag.yml
---
 - hosts: web
   user: root
   tasks:
   - name: touch file
     file: path=/root/nihao.txt state=touch
     tags: nihao
   - name: mkdir file
     file: path=/root/xingdian state=directory
     tags: xingdian
   - name: touch file1
     file: path=/root/file1.txt state=touch
     tags: file1
```

#### 5.案例五

​		批量安装apache服务，并使用浏览器访问到对应的项目

```yaml
[root@xingdian /]# vim /home/ansible/apache.yml
---
 - hosts: web
   user: root
   tasks:
   - name: apache install
     yum: name=httpd state=latest
   - name: mkdir file
     file: path=/web1 state=directory mode=777
   - name: copy index    
     copy: src=/index.html dest=/web1
   - name: Listen 
     shell: echo "Listen 81" >> /etc/httpd/conf/httpd.conf
   - name: copy conf
     copy: src=/wordpress.conf dest=/etc/httpd/conf.d/
     notify: start httpd
   handlers:
   - name: start httpd
     service: name=httpd state=restarted
```

检测语法

```shell
[root@ansible-server ansible]# ansible-playbook --syntax-check apache.yml 
playbook: list.yml
```

运行剧本

```shell
[root@xingdian /]# ansible-playbook /home/ansible/apache.yml
```

## 六：变量使用

#### 1.语法格式

```shell
变量调用语法： 
{{ var_name }}
```

#### 2.案例一

​		通过命令行传递变量：（通过--extra-vars或-e选项来传递key=value变量）

```shell
[root@xingdian /]# ansible-playbook release.yml -e "user=starbuck"
```

​		传递字典

```shell
[root@xingdian ansible]# ansible-playbook conf.yml  -e '{"conf81":"/root/81.conf","conf82":"/root/conf82"}'
```

#### 3.案例二

​		创建变量目录

```shell
[root@ansible-server ~]# mkdir /etc/ansible/vars
[root@ansible-server ~]# cd /etc/ansible/vars/
```

​		创建变量文件

```shell
[root@ansible-server vars]# vim file.yml
src_path: /root/test/a.txt
dest_path: /opt/test/
```

​		创建一个测试文件

```shell
[root@ansible-server vars]# mkdir /root/test
[root@ansible-server vars]# echo 123 >/root/test/a.txt
```

​		创建playbook引用变量文件

```yaml
[root@ansible-server vars]# cd /etc/ansible/
[root@ansible-server ansible]# vim vars.yml
- hosts: ansible-web1
  user: root
  vars_files:
   - /etc/ansible/vars/file.yml
  tasks:
   - name: create directory
     file: path={{ dest_path }} mode=755 state=directory
   - name: copy file
     copy: src={{ src_path }} dest={{ dest_path }}
```

​		检测语法

```shell
[root@ansible-server ansible]# ansible-playbook --syntax-check vars.yml
playbook: vars.yml
```

​		运行剧本

```shell
[root@ansible-server ansible]# ansible-playbook  vars.yml
```

#### 4.案例三

​		文件中包含变量

```yaml
[root@xingdian ansible]# vim conf.yml 
- hosts: web
  remote_user: root
  vars:
    httpd:
      conf80: /root/80.conf
      conf8080: /root/8080.conf
  tasks:
  - name: task1
    file:
      path: "{{httpd.conf80}}"
      state: touch
  - name: task2
    file:
      path: "{{httpd.conf8080}}"
      state: touch
```

​		检测语法

```shell
[root@xingdian ansible]# ansible-playbook --syntax-check conf.yml
```

​		运行剧本

```shell
[root@xingdian ansible]# ansible-playbook conf.yml
```

#### 5.案例四

​		在主机清单中定义变量

```shell
[root@xingdian ansible]# tail -5 /etc/ansible/hosts 
[web]
10.0.0.111
[web:vars]
conf81=ppp
conf82=ooo
```

​		创建剧本

```yml
[root@xingdian ansible]# cat conf.yml 
- hosts: web
  remote_user: root
  tasks:
  - name: task1
    file:
      path: "{{ conf81 }}"
      state: touch
  - name: task2
    file:
      path: "{{ conf82 }}"
      state: touch
```

​		语法检测

```shell
[root@xingdian ansible]# ansible-playbook --syntax-check conf.yml
```

​		运行剧本

```shell
[root@xingdian ansible]# ansible-playbook conf.yml
```

#### 6.案例五

​		set_fact自定义facts变量

​		set_fact模块可以自定义facts，这些自定义的facts可以通过template或者变量的方式在playbook中使用。如果你想要获取一 个进程使用的内存的百分比，则必须通过set_fact来进行计算之后得出其值，并将其值在playbook中引用

​		配置mysql innodb buffer size的示例

```yaml
 - name: Configure MySQL
   hosts: web
   tasks:
   - name: Calculate InnoDB buffer pool size
     set_fact: innodb_buffer_pool_size_mb="{{ ansible_swapfree_mb / 2 }}"
   - name: nihao
     template: src=/my.cnf dest=/etc/my.cnf owner=root group=root mode=0644 
```

​		参数说明

```shell
set_fact: innodb_buffer_pool_size_mb="{{ ansible_memtotal_mb / 2 }}"
    通过sey_fact去定义，而不是直接执行   
template: src=templates/my.cnf dest=/etc/my.cnf owner=root group=root mode=0644 
    template：这个是一个模板  可以传变量
```

​		my.cnf文件

```shell
[mysqld]
datadir=/var/lib/mysql
socket=/var/lib/mysql/mysql.sock
# Disabling symbolic-links is recommended to prevent assorted
security risks
symbolic-links=0
 
# Configure the buffer pool
innodb_buffer_pool_size = {{ innodb_buffer_pool_size_mb|int }}M
[mysqld_safe]
log-error=/var/log/mysqld.log
pid-file=/var/run/mysqld/mysqld.pid
```

## 七：Role角色

#### 1.介绍

​		Roles是在ansible中，playbook的目录组织结构

​		每一个角色是有名字的 ，他是一个目录 ，可以包含子目录

​		以特定的层级目录结构进行组织的tasks、variables、handlers、templates、files等

#### 2.目录作用

role_name：这个是角色的名称

files：存储由copy或script等模块调用的文件

tasks：专门存储任务的目录，一个角色可以定义多个任务；此目录中至少应该有一个名为main.yml的文件，用于定义各task；其它的文件需要由main.yml进行“包含”调用

handlers：条件  前一个任务执行成功去执行下面的，处理特定事物的文件，此目录中至少应该有一个名为main.yml的文件，用于定义各handler；其它的文件需要由main.yml进行“包含”调用

vars：变量 ，定义变量的文件；此目录中至少应该有一个名为main.yml的文件，用于定义各variable；其它的文件需要由main.yml进行“包含”调用

templates：模板  使用变量的文件存储由template模块调用的模板文本

meta：此目录中至少应该有一个名为main.yml的文件，定义当前角色的特殊设定及其依赖关系；其它的文件需要由main.yml进行“包含”调用

default：此目录中至少应该有一个名为main.yml的文件，用于设定默认变量

#### 3.目录案例

​		nginx是一个角色的名字，角色里用到文件放在files中，通过创建playbook来调用这些角色

<img src="https://xingdian-image.oss-cn-beijing.aliyuncs.com/xingdian-image/image-20230303004925730.png" alt="image-20230303004925730" style="zoom:50%;" />

#### 4.项目案例

​		准备目录结构

```shell
[root@ansible-server ~]# cd /etc/ansible/roles/  #role位自带目录，如果不存在可以创建
[root@ansible-server roles]# mkdir nginx/{files,handlers,tasks,templates,vars} -p
```

​		创建文件

```shell
[root@ansible-server roles]# touch site.yml nginx/{handlers,tasks,vars}/main.yml
[root@ansible-server roles]# yum install -y tree    
[root@xingdian roles]# tree nginx/
nginx/
├── files
├── handlers
│   └── main.yml
├── tasks
│   └── main.yml
├── templates
└── vars
    └── main.yml

5 directories, 3 files
```

​		创建nginx的测试文件

```shell
[root@ansible-server roles]# echo 1234 > nginx/files/index.html
```

​		安装nginx并配置模板

```shell
[root@ansible-server roles]# yum install -y nginx && cp /etc/nginx/nginx.conf nginx/templates/nginx.conf.j2
```

​		编写任务

```yml
[root@ansible-server roles]# vim nginx/tasks/main.yml
---
- name: install epel
  yum: name=epel-release state=latest
- name: install nginx
  yum: name=nginx state=latest
- name: copy nginx.conf templte
  template: src=nginx.conf.j2 dest=/etc/nginx/nginx.conf
- name: copy index.html
  copy: src=index.html dest=/usr/share/nginx/html/index.html
  notify: start nginx  
```

​		templates模板

```shell
[root@ansible-server roles]# vim nginx/templates/nginx.conf.j2
```

​		自定义变量

![image-20230303005728244](https://xingdian-image.oss-cn-beijing.aliyuncs.com/xingdian-image/image-20230303005728244.png)

​		编写变量

```shell
[root@ansible-server roles]# vim nginx/vars/main.yml  #添加如下内容
worker_connections: 2
```

​		编写handlers

```yaml
[root@ansible-server roles]# vim nginx/handlers/main.yml #编写如下内容
---
- name: start nginx
  service: name=nginx state=started
```

​		编写剧本

```yml
[root@ansible-server roles]# vim site.yml
---
- hosts: webservers4
  user: root
  roles:
   - nginx
```

​		检测语法

```shell
[root@ansible-server roles]# ansible-playbook site.yml --syntax-check
playbook: site.yml
```

​		执行剧本

```shell
[root@ansible-server roles]# ansible-playbook site.yml
```

​		查看

```shell
[root@ansible-web4 ~]# netstat -lntp 
[root@ansible-web4 ~]# cat /etc/nginx/nginx.conf | grep pro
#worker_processes auto;
worker_processes 2;
```

​		访问

```shell
[root@ansible-web4 ~]# http://172.17.0.2
```

注意：（了解）

​		ansible会使用jinja2模板来修改被管理主机的配置文件；使用ansible的jinja2模板，也就是template模块，该模块和copy模块一样，都是将文件复制到远端主机上；区别在于template模块可以获取要复制的文件中变量的值；而copy则是原封不动的把文件内容复制过去，比如针对不同的主机定义不同的变量，template会在将配置文件分发出去之前读取变量到jinja2模板，然后分发到不通的被管理主机上；ansible允许jinja2模板中使用条件判断和循环，但是jinja2判断循环语法不允许在playbook中使用；jinja2 文件件以 .j2 为后缀， 也可以不写后缀





